
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Lead_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lead_events = await db.lead_events.create(
            {
                id: data.id || undefined,
        
        event_type: data.event_type
        ||
        null
            ,
            
        from_value: data.from_value
        ||
        null
            ,
            
        to_value: data.to_value
        ||
        null
            ,
            
        meta_json: data.meta_json
        ||
        null
            ,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await lead_events.setLead( data.lead || null, {
            transaction,
        });
        
        await lead_events.setActor_user( data.actor_user || null, {
            transaction,
        });
        

        

        

        return lead_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const lead_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_type: item.event_type
            ||
            null
            ,
            
                from_value: item.from_value
            ||
            null
            ,
            
                to_value: item.to_value
            ||
            null
            ,
            
                meta_json: item.meta_json
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const lead_events = await db.lead_events.bulkCreate(lead_eventsData, { transaction });

        // For each item created, replace relation files
        

        return lead_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const lead_events = await db.lead_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.from_value !== undefined) updatePayload.from_value = data.from_value;
        
        
        if (data.to_value !== undefined) updatePayload.to_value = data.to_value;
        
        
        if (data.meta_json !== undefined) updatePayload.meta_json = data.meta_json;
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await lead_events.update(updatePayload, {transaction});

        
        
        if (data.lead !== undefined) {
            await lead_events.setLead(
              
              data.lead,
              
              { transaction }
            );
        }
        
        if (data.actor_user !== undefined) {
            await lead_events.setActor_user(
              
              data.actor_user,
              
              { transaction }
            );
        }
        

        
        

        

        return lead_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lead_events = await db.lead_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of lead_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of lead_events) {
                await record.destroy({transaction});
            }
        });


        return lead_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const lead_events = await db.lead_events.findByPk(id, options);

        await lead_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await lead_events.destroy({
            transaction
        });

        return lead_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const lead_events = await db.lead_events.findOne(
            { where },
            { transaction },
        );

        if (!lead_events) {
            return lead_events;
        }

        const output = lead_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.lead = await lead_events.getLead({
            transaction
        });
        
        
        output.actor_user = await lead_events.getActor_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.leads,
        as: 'lead',
        
        where: filter.lead ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lead.split('|').map(term => Utils.uuid(term)) } },
            {
              keyword: {
                [Op.or]: filter.lead.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'actor_user',
        
        where: filter.actor_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.actor_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.actor_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.from_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lead_events',
                        'from_value',
                        filter.from_value,
                    ),
                };
            }
            
            if (filter.to_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lead_events',
                        'to_value',
                        filter.to_value,
                    ),
                };
            }
            
            if (filter.meta_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lead_events',
                        'meta_json',
                        filter.meta_json,
                    ),
                };
            }
            

            
            

            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                event_type: filter.event_type,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.lead_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'lead_events',
                        'event_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.lead_events.findAll({
            attributes: [ 'id', 'event_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_type,
        }));
    }

    
};

